> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/reference/reference-client/app-dropuser.md).

# dropuser

### dropuser

dropuser — remove a PostgreSQL user account

### Synopsis

`dropuser` \[*`connection-option`*...] \[*`option`*...] \[*`username`*]

### Description

dropuser removes an existing PostgreSQL user. Superusers can use this command to remove any role; otherwise, only non-superuser roles can be removed, and only by a user who possesses the `CREATEROLE` privilege and has been granted `ADMIN OPTION` on the target role.

dropuser is a wrapper around the SQL command [`DROP ROLE`](/reference/sql-commands/sql-droprole.md). There is no effective difference between dropping users via this utility and via other methods for accessing the server.

### Options

dropuser accepts the following command-line arguments:

*`username`* : Specifies the name of the PostgreSQL user to be removed. You will be prompted for a name if none is specified on the command line and the `-i`/`--interactive` option is used.

`-e`\
`--echo` : Echo the commands that dropuser generates and sends to the server.

`-i`\
`--interactive` : Prompt for confirmation before actually removing the user, and prompt for the user name if none is specified on the command line.

`-V`\
`--version` : Print the dropuser version and exit.

`--if-exists` : Do not throw an error if the user does not exist. A notice is issued in this case.

`-?`\
`--help` : Show help about dropuser command line arguments, and exit.

dropuser also accepts the following command-line arguments for connection parameters:

`-h host`\
`--host=host` : Specifies the host name of the machine on which the server is running. If the value begins with a slash, it is used as the directory for the Unix domain socket.

`-p port`\
`--port=port` : Specifies the TCP port or local Unix domain socket file extension on which the server is listening for connections.

`-U username`\
`--username=username` : User name to connect as (not the user name to drop).

`-w`\
`--no-password` : Never issue a password prompt. If the server requires password authentication and a password is not available by other means such as a `.pgpass` file, the connection attempt will fail. This option can be useful in batch jobs and scripts where no user is present to enter a password.

`-W`\
`--password` : Force dropuser to prompt for a password before connecting to a database.

```
This option is never essential, since
dropuser will automatically prompt
for a password if the server demands password authentication.
However, dropuser will waste a
connection attempt finding out that the server wants a password.
In some cases it is worth typing `-W` to avoid the extra
connection attempt.
```

### Environment

`PGHOST`\
`PGPORT`\
`PGUSER` : Default connection parameters

`PG_COLOR` : Specifies whether to use color in diagnostic messages. Possible values are `always`, `auto` and `never`.

This utility, like most other PostgreSQL utilities, also uses the environment variables supported by libpq (see [Section 32.15](/client-interfaces/libpq/libpq-envars.md)).

### Diagnostics

In case of difficulty, see [DROP ROLE](/reference/sql-commands/sql-droprole.md) and [psql](/reference/reference-client/app-psql.md) for discussions of potential problems and error messages. The database server must be running at the targeted host. Also, any default connection settings and environment variables used by the libpq front-end library will apply.

### Examples

To remove user `joe` from the default database server:

```

$ dropuser joe
```

To remove user `joe` using the server on host `eden`, port 5000, with verification and a peek at the underlying command:

```

$ dropuser -p 5000 -h eden -i -e joe
Role "joe" will be permanently removed.
Are you sure? (y/n) y
DROP ROLE joe;
```

### See Also

[createuser](/reference/reference-client/app-createuser.md), [DROP ROLE](/reference/sql-commands/sql-droprole.md)

***

原文：[PostgreSQL 18.6 Documentation](https://www.postgresql.org/docs/18/app-dropuser.html)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.postgresql.tw/reference/reference-client/app-dropuser.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
